# coding: utf-8

"""
    FINBOURNE Candela Platform Web API

    FINBOURNE Technology  # noqa: E501

    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic.v1 import BaseModel, Field, StrictStr, ValidationError, validator
from finbourne_candela.models.confirm_dto import ConfirmDTO
from finbourne_candela.models.insert_context_dto import InsertContextDTO
from finbourne_candela.models.intent_dto import IntentDTO
from finbourne_candela.models.no_op_dto import NoOpDTO
from finbourne_candela.models.response_dto import ResponseDTO
from finbourne_candela.models.switch_dto import SwitchDTO
from finbourne_candela.models.use_tool_dto import UseToolDTO
from typing import Union, Any, List, TYPE_CHECKING
from pydantic.v1 import StrictStr, Field

NODES_ONE_OF_SCHEMAS = ["ConfirmDTO", "InsertContextDTO", "IntentDTO", "NoOpDTO", "ResponseDTO", "SwitchDTO", "UseToolDTO"]

class Nodes(BaseModel):
    """
    Nodes
    """
    # data type: ResponseDTO
    oneof_schema_1_validator: Optional[ResponseDTO] = None
    # data type: IntentDTO
    oneof_schema_2_validator: Optional[IntentDTO] = None
    # data type: ConfirmDTO
    oneof_schema_3_validator: Optional[ConfirmDTO] = None
    # data type: NoOpDTO
    oneof_schema_4_validator: Optional[NoOpDTO] = None
    # data type: UseToolDTO
    oneof_schema_5_validator: Optional[UseToolDTO] = None
    # data type: SwitchDTO
    oneof_schema_6_validator: Optional[SwitchDTO] = None
    # data type: InsertContextDTO
    oneof_schema_7_validator: Optional[InsertContextDTO] = None
    if TYPE_CHECKING:
        actual_instance: Union[ConfirmDTO, InsertContextDTO, IntentDTO, NoOpDTO, ResponseDTO, SwitchDTO, UseToolDTO]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(NODES_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = Nodes.construct()
        error_messages = []
        match = 0
        matchclass = ""
        # validate data type: ResponseDTO
        if not isinstance(v, ResponseDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ResponseDTO`")
        else:
            match += 1
            matchclass = matchclass + " ResponseDTO"
        # validate data type: IntentDTO
        if not isinstance(v, IntentDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `IntentDTO`")
        else:
            match += 1
            matchclass = matchclass + " IntentDTO"
        # validate data type: ConfirmDTO
        if not isinstance(v, ConfirmDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ConfirmDTO`")
        else:
            match += 1
            matchclass = matchclass + " ConfirmDTO"
        # validate data type: NoOpDTO
        if not isinstance(v, NoOpDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NoOpDTO`")
        else:
            match += 1
            matchclass = matchclass + " NoOpDTO"
        # validate data type: UseToolDTO
        if not isinstance(v, UseToolDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UseToolDTO`")
        else:
            match += 1
            matchclass = matchclass + " UseToolDTO"
        # validate data type: SwitchDTO
        if not isinstance(v, SwitchDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SwitchDTO`")
        else:
            match += 1
            matchclass = matchclass + " SwitchDTO"
        # validate data type: InsertContextDTO
        if not isinstance(v, InsertContextDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `InsertContextDTO`")
        else:
            match += 1
            matchclass = matchclass + " InsertContextDTO"
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in Nodes with oneOf schemas: ConfirmDTO, InsertContextDTO, IntentDTO, NoOpDTO, ResponseDTO, SwitchDTO, UseToolDTO. Details: Matched classes " + matchclass)
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in Nodes with oneOf schemas: ConfirmDTO, InsertContextDTO, IntentDTO, NoOpDTO, ResponseDTO, SwitchDTO, UseToolDTO. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Nodes:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Nodes:
        """Returns the object represented by the json string"""
        instance = Nodes.construct()
        error_messages = []
        match = 0
        matchclass = ""
        

        # deserialize data into ResponseDTO
        try:
            instance.actual_instance = ResponseDTO.from_json(json_str)
            match += 1
            matchclass =matchclass + " ResponseDTO"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into IntentDTO
        try:
            instance.actual_instance = IntentDTO.from_json(json_str)
            match += 1
            matchclass =matchclass + " IntentDTO"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ConfirmDTO
        try:
            instance.actual_instance = ConfirmDTO.from_json(json_str)
            match += 1
            matchclass =matchclass + " ConfirmDTO"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into NoOpDTO
        try:
            instance.actual_instance = NoOpDTO.from_json(json_str)
            match += 1
            matchclass =matchclass + " NoOpDTO"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UseToolDTO
        try:
            instance.actual_instance = UseToolDTO.from_json(json_str)
            match += 1
            matchclass =matchclass + " UseToolDTO"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SwitchDTO
        try:
            instance.actual_instance = SwitchDTO.from_json(json_str)
            match += 1
            matchclass =matchclass + " SwitchDTO"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into InsertContextDTO
        try:
            instance.actual_instance = InsertContextDTO.from_json(json_str)
            match += 1
            matchclass =matchclass + " InsertContextDTO"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into Nodes with oneOf schemas: ConfirmDTO, InsertContextDTO, IntentDTO, NoOpDTO, ResponseDTO, SwitchDTO, UseToolDTO. Matches: "+matchclass+", Details: " + ", ".join(error_messages) + ", JSON: " + json_str)
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into Nodes with oneOf schemas: ConfirmDTO, InsertContextDTO, IntentDTO, NoOpDTO, ResponseDTO, SwitchDTO, UseToolDTO. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

        def __str__(self):
            """For `print` and `pprint`"""
            return pprint.pformat(self.dict(by_alias=False))
    
        def __repr__(self):
            """For `print` and `pprint`"""
            return self.to_str()
    
        def to_str(self) -> str:
            """Returns the string representation of the model using alias"""
            return pprint.pformat(self.dict(by_alias=True))
