# coding: utf-8

"""
    FINBOURNE Candela Platform Web API

    FINBOURNE Technology  # noqa: E501

    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic.v1 import BaseModel, Field, StrictStr, ValidationError, validator
from finbourne_candela.models.dto_bool import DTOBool
from finbourne_candela.models.dto_enum import DTOEnum
from finbourne_candela.models.dto_int import DTOInt
from finbourne_candela.models.dto_obj import DTOObj
from finbourne_candela.models.dto_real import DTOReal
from finbourne_candela.models.dto_str import DTOStr
from typing import Union, Any, List, TYPE_CHECKING
from pydantic.v1 import StrictStr, Field

OBJ_ONE_OF_SCHEMAS = ["DTOArr", "DTOBool", "DTODict", "DTOEnum", "DTOInt", "DTOObj", "DTOReal", "DTOStr"]

class Obj(BaseModel):
    """
    Obj
    """
    # data type: DTODict
    oneof_schema_1_validator: Optional[DTODict] = None
    # data type: DTOArr
    oneof_schema_2_validator: Optional[DTOArr] = None
    # data type: DTOObj
    oneof_schema_3_validator: Optional[DTOObj] = None
    # data type: DTOEnum
    oneof_schema_4_validator: Optional[DTOEnum] = None
    # data type: DTOStr
    oneof_schema_5_validator: Optional[DTOStr] = None
    # data type: DTOBool
    oneof_schema_6_validator: Optional[DTOBool] = None
    # data type: DTOReal
    oneof_schema_7_validator: Optional[DTOReal] = None
    # data type: DTOInt
    oneof_schema_8_validator: Optional[DTOInt] = None
    if TYPE_CHECKING:
        actual_instance: Union[DTOArr, DTOBool, DTODict, DTOEnum, DTOInt, DTOObj, DTOReal, DTOStr]
    else:
        actual_instance: Any
    one_of_schemas: List[str] = Field(OBJ_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = Obj.construct()
        error_messages = []
        match = 0
        matchclass = ""
        # validate data type: DTODict
        if not isinstance(v, DTODict):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DTODict`")
        else:
            match += 1
            matchclass = matchclass + " DTODict"
        # validate data type: DTOArr
        if not isinstance(v, DTOArr):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DTOArr`")
        else:
            match += 1
            matchclass = matchclass + " DTOArr"
        # validate data type: DTOObj
        if not isinstance(v, DTOObj):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DTOObj`")
        else:
            match += 1
            matchclass = matchclass + " DTOObj"
        # validate data type: DTOEnum
        if not isinstance(v, DTOEnum):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DTOEnum`")
        else:
            match += 1
            matchclass = matchclass + " DTOEnum"
        # validate data type: DTOStr
        if not isinstance(v, DTOStr):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DTOStr`")
        else:
            match += 1
            matchclass = matchclass + " DTOStr"
        # validate data type: DTOBool
        if not isinstance(v, DTOBool):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DTOBool`")
        else:
            match += 1
            matchclass = matchclass + " DTOBool"
        # validate data type: DTOReal
        if not isinstance(v, DTOReal):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DTOReal`")
        else:
            match += 1
            matchclass = matchclass + " DTOReal"
        # validate data type: DTOInt
        if not isinstance(v, DTOInt):
            error_messages.append(f"Error! Input type `{type(v)}` is not `DTOInt`")
        else:
            match += 1
            matchclass = matchclass + " DTOInt"
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in Obj with oneOf schemas: DTOArr, DTOBool, DTODict, DTOEnum, DTOInt, DTOObj, DTOReal, DTOStr. Details: Matched classes " + matchclass)
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in Obj with oneOf schemas: DTOArr, DTOBool, DTODict, DTOEnum, DTOInt, DTOObj, DTOReal, DTOStr. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Obj:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Obj:
        """Returns the object represented by the json string"""
        instance = Obj.construct()
        error_messages = []
        match = 0
        matchclass = ""
        

        # deserialize data into DTODict
        try:
            instance.actual_instance = DTODict.from_json(json_str)
            match += 1
            matchclass =matchclass + " DTODict"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DTOArr
        try:
            instance.actual_instance = DTOArr.from_json(json_str)
            match += 1
            matchclass =matchclass + " DTOArr"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DTOObj
        try:
            instance.actual_instance = DTOObj.from_json(json_str)
            match += 1
            matchclass =matchclass + " DTOObj"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DTOEnum
        try:
            instance.actual_instance = DTOEnum.from_json(json_str)
            match += 1
            matchclass =matchclass + " DTOEnum"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DTOStr
        try:
            instance.actual_instance = DTOStr.from_json(json_str)
            match += 1
            matchclass =matchclass + " DTOStr"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DTOBool
        try:
            instance.actual_instance = DTOBool.from_json(json_str)
            match += 1
            matchclass =matchclass + " DTOBool"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DTOReal
        try:
            instance.actual_instance = DTOReal.from_json(json_str)
            match += 1
            matchclass =matchclass + " DTOReal"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into DTOInt
        try:
            instance.actual_instance = DTOInt.from_json(json_str)
            match += 1
            matchclass =matchclass + " DTOInt"
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into Obj with oneOf schemas: DTOArr, DTOBool, DTODict, DTOEnum, DTOInt, DTOObj, DTOReal, DTOStr. Matches: "+matchclass+", Details: " + ", ".join(error_messages) + ", JSON: " + json_str)
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into Obj with oneOf schemas: DTOArr, DTOBool, DTODict, DTOEnum, DTOInt, DTOObj, DTOReal, DTOStr. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

        def __str__(self):
            """For `print` and `pprint`"""
            return pprint.pformat(self.dict(by_alias=False))
    
        def __repr__(self):
            """For `print` and `pprint`"""
            return self.to_str()
    
        def to_str(self) -> str:
            """Returns the string representation of the model using alias"""
            return pprint.pformat(self.dict(by_alias=True))

from finbourne_candela.models.dto_arr import DTOArr
from finbourne_candela.models.dto_dict import DTODict
Obj.update_forward_refs()
